#include <fstream>
#include <climits>
#include "db.h"

using namespace std;

void db_saveComputer(ostream& os, const Computer& Computer) {
    os << Computer.ID << endl;
    os << Computer.hourPrice << endl;
    os << Computer.computerPrice << endl;
    os << Computer.operatingSystem << endl;
    os << Computer.moneyEarned << endl;
    os << Computer.rentedByCustomer << endl;
    os << Computer.returnedCount << endl;
    os << Computer.rentedTimes << endl;
}

Computer db_loadComputer(istream& is) {
    Computer Computer;
    is.ignore(INT_MAX, '\n');
    getline(is, Computer.ID);
    is >> Computer.hourPrice;
    is >> Computer.computerPrice;
    is >> Computer.operatingSystem;
    is >> Computer.moneyEarned;
    is >> Computer.rentedByCustomer;
    is >> Computer.returnedCount;
    is >> Computer.rentedTimes;
    return Computer;
}

void db_saveCustomer(ostream& os, const Customer& customer) {
    os << customer.name << endl;
    os << customer.personalcode << endl;
    os << customer.moneyEarned << endl;
}

Customer db_loadCustomer(istream& is) {
    Customer customer;
    is.ignore(INT_MAX, '\n');
    getline(is, customer.name);
    getline(is, customer.personalcode);
    is >> customer.moneyEarned;
    return customer;
}

void db_saveComputerRental(std::string fileName, const ComputerRental& rental) {
    ofstream os(fileName.c_str());
    os << rental.computers.size() << endl;
    for (int i = 0; i < rental.computers.size(); i++) {
        db_saveComputer(os, rental.computers[i]);
    }
    os << rental.customers.size() << endl;
    for (int i = 0; i < rental.customers.size(); i++) {
        db_saveCustomer(os, rental.customers[i]);
    }
    os.flush();
    os.close();
}

ComputerRental db_loadComputerRental(std::string fileName) {
    ifstream is(fileName.c_str());
    ComputerRental rental;
    int ComputerCount = 0;
    is >> ComputerCount;
    for (int i = 0; i < ComputerCount; i++) {
        Computer computer = db_loadComputer(is);
        rental.computers.push_back(computer);
    }
    int customerCount = 0;
    is >> customerCount;
    for (int i = 0; i < customerCount; i++) {
        Customer customer = db_loadCustomer(is);
        rental.customers.push_back(customer);
    }
    is.close();
    return rental;
}
