#ifndef DOMAIN_H
#define DOMAIN_H

#include <string>
#include <vector>

struct Computer {
    static const int NOT_RENTED = 0;

    std::string ID; //inventorizacijos numeris
    std::string operatingSystem; //windows,linux,mac
    double hourPrice;
    double computerPrice; 
    int returnedCount;
    int rentedTimes;
    int rentedByCustomer; // numeruosime nuo 1
    double moneyEarned;
};

typedef std::vector<Computer> Computers;

struct Customer {
    std::string name;
    std::string personalcode;
    double moneyEarned;
};

typedef std::vector<Customer> Customers;

struct ComputerRental {
    Computers computers;
    Customers customers;
};

Computer computer_create(std::string ID, std::string operatingSystem, double hourPrice,double computerPrice, int returnedCount,int rentedTimes);

Customer customer_create(std::string ID, std::string personalcode);

bool computers_isComputerNoValid(const Computers& Computers, int ComputerNo);

bool computers_isRented(const Computers& Computers, int ComputerNo);


#endif /* DOMAIN_H */